<?
    class B_Attach
    {
        var $_config;

        function B_Attach()
        {
            $this->_config = array
            (
                'ext.txt'     => 'text/plain',
                'ext.html'    => 'text/html',
                'ext.htm'     => 'text/htm',
                'ext.css'     => 'text/css',
                'ext.rtf'     => 'text/rtf',
                'ext.gif'     => 'image/gif',
                'ext.jpg'     => 'image/jpeg',
                'ext.bmp'     => 'image/bmp',
                'ext.png'     => 'image/png',
                'ext.tif'     => 'image/tiff',
                'ext.tiff'    => 'image/tiff',
                'ext.zip'     => 'application/zip',
                'ext.doc'     => 'application/msword',
                'ext.pdf'     => 'application/pdf',
                'ext.ai'      => 'application/postscript',
                'ext.eps'     => 'application/postscript',
                'ext.ps'      => 'application/postscript',
                'ext.tex'     => 'application/x-tex',
                'ext.mid'     => 'audio/midi',
                'ext.mp3'     => 'audio/mpeg',
                'ext.avi'     => 'video/x-msvideo',
                'ext.mov'     => 'video/quicktime',
                'ext.mpe'     => 'video/mpeg',
                'ext.mpg'     => 'video/mpeg',
                'ext.mpeg'    => 'video/mpeg',
                'ext.default' => 'application/octet-stream',
            );          
        }

        function create(&$fp, $bound, $file)
        {
            $name = addcslashes(basename($file), '"');
            $mime  = $this->_getmime($name);

            list ($himime) = explode('/', $mime, 2);

            $header = "------{$bound}\r\n".
                    "Content-Type: $mime; charset=utf-8; name=\"{$name}\"\r\n".
                    "Content-Disposition: attachment; filename=\"{$name}\"\r\n".
                    "Content-Transfer-Encoding: quoted-printable\r\n\r\n";

            if ($fi = fopen($file, 'r'))
            {
                flock($fi, LOCK_SH);
                fwrite($fp, $header);

                $this->_qp($fp, $fi, $himime == 'text');
                fclose($fi);

                fwrite($fp, "=\r\n");

                return true;
            }

            return false;
        }

        function _getmime($name)
        {
            $idx = strrchr($name, '.');
            $ext = $idx === FALSE ? $name : 'ext'.$idx;

            return $this->_config[isset($this->_config[$ext]) ? $ext : 'ext.default'];
        }
        
        function _qp(&$fp, &$fi, $istext = false)
        {
            if ($istext)
            {
                $from = array('=',   "\x00");
                $to   = array('=3D', '=00');
            }
            else
            {
                $from = array('=', "\x00", "\n", "\r");
                $to   = array('=3D', '=00', '=0A', '=0D');
            }

            while (!feof($fi))
            {
                $str = fread($fi, 512);
                $str = str_replace($from, $to, $str)."=\r\n";

                fwrite($fp, $str);
            }
        }
    }

    class B_SMTP
    {
        var $_fp = null;

        function B_SMTP($server, $port)
        {
            $this->_fp = fsockopen($server, $port, $errno, $errstr, 60);
            if (!is_resource($this->_fp)) return $this->_fp = null;

            if (function_exists('socket_set_timeout'))
            socket_set_timeout($this->_fp, 2);
        }

        function isconnected()
        {
            return $this->_fp !== null;
        }

        function send($str)
        {
            fwrite($this->_fp, $str);
        }

        function sendrecv($str)
        {
            $this->send($str."\r\n");
            echo '<< '. substr($str, 0, 80), "\r\n";
            return $this->recv();
        }

        function recv()
        {
            while (!feof($this->_fp))
            {
                $str = fgets($this->_fp, 2048);

                if ($str <> '') echo '>> ', $str;
                if (preg_match('/^(\d+) /', $str, $m))
                return (int) $m[1];
            }
            return null;
        }

        function close()
        {
            fclose($this->_fp);
            $this->_fp = null;
        }
    }

    class B_Message
    {
        function create(&$fp, $bound, $filenames_array)
        {
            $body = "Content-Transfer-Encoding: 8bit\r\n".
                    "Content-Type: multipart/mixed; charset=utf-8;\r\n".
                    " boundary=\"----{$bound}\"\r\n\r\n";

            fwrite($fp, $body);

            for ($i = sizeof($filenames_array) - 1; $i>=0; $i--)
            {
                $file = &new B_Attach();
                $ret  = $file->create($fp, $bound, $filenames_array[$i]);

                if ($ret && $i)
                fwrite($fp, "\r\n");
            }

            fwrite($fp, "------{$bound}--");
        }

        function send($server, $port, $from, $to, $bound2, &$fp, $subject)
        {
            $smtp = &new B_SMTP($server, $port);
            if ($smtp->isconnected())
            {
                if
                (
                    ($a = $smtp->recv()) == 220 && 
                    ($a = $smtp->sendrecv('HELO bolk_8_bit')) == 250 && 
                    ($a = $smtp->sendrecv("MAIL FROM: <$from>")) == 250 &&
                    ($a = $smtp->sendrecv("RCPT TO: <$to>")) == 250 &&
                    ($a = $smtp->sendrecv("DATA")) == 354
                )
                {
                    $header = "From: $from\r\n".
                              "To: $to\r\n".
                              "Subject: $subject\r\n".
                              "X-Mailer: BOLK 8bit sender 0.30\r\n".
                              "Content-Type: message/rfc822; name=\"1.msg\"; charset=utf-8;\r\n".
                              " boundary=\"------------{$bound2}\"\r\n".
                              "Content-Disposition: inline\r\n".
                              "Content-Transfer-Encoding: 8bit\r\n\r\n";

                    $smtp->send($header);
                    while (!feof($fp))
                    {
                        $str = fgets($fp, 16384);
                        if ($str{0} == '.') $str = '.'.$str;

                        $smtp->send($str);
                    }

                    $smtp->send("\r\n--------------{$bound2}--\r\n\r\n");

                    if (($a = $smtp->sendrecv('.')) == 250)
                    {
                        $smtp->send('QUIT');
                        return true;
                    }
                }

                echo 'Error: invalid server answer: ', $a,".\r\n";
                return false;
            }
            else
            {
                echo 'Error: cannot connect to server \'',
                $server, "'.\r\n";
            }
        }
    }

    // Try to determine SMTP server
    if ($_SERVER['argc'])
    {
        if ($_SERVER['argv'][1] == '-t')
        {
            list (,, $smtp) = array_splice($_SERVER['argv'], 0, 3);
            list ($from, $to) = U_fromto();
        }
        else
        {
            array_shift($_SERVER['argv']);
            list ($from, $to) = U_fromto();

            list(,$smtp) = explode('@', $to);

            if (function_exists('getmxrr'))
            {
                getmxrr($smtp, $mxhosts, $weight);
                $smtps = array();
                for ($i = 0; $i<sizeof($mxhosts); $i++)
                $smtps[$mxhosts[$i]] = isset($smtps[$mxhosts[$i]]) ?
                min($smtps[$mxhosts[$i]], $weight[$i]) :
                $weight[$i];

                asort($smtps);
                list ($smtp) = array_keys($smtps);
            }
            elseif (function_exists('proc_open'))
            {
                $desc = array
                (
                    array('pipe', 'r'),
                    array('pipe', 'w'),
                    array('pipe', 'w'),
                );

                $p = proc_open('nslookup', $desc, $pipes);

                if (is_resource($p))
                {
                    fwrite($pipes[0], "set type=MX\r\n$smtp\r\nexit\r\n");
                    
                    for ($smtps = array(); !feof($pipes[1]);)
                    if (preg_match('/\s+MX\s+preference\s*=\s*(\d+),?\s*mail exchanger\s*=\s*(.+)$/i',
                    rtrim(fgets($pipes[1], 2048)), $r))
                    $smtps[$r[2]] = isset($smtps[$r[2]]) ?
                    min($smtps[$r[2]], (int) $r[1]) : (int) $r[1];

                    asort($smtps);

                    list ($smtp) = array_keys($smtps);
                    
                    proc_close($p);
                }
            }
        }
    }

    if ($to === null || $from === null || $smtp === null || !sizeof($_SERVER['argv']))
    {
        echo <<<HELP
-------------------------------------------------------------------------------
Send file(s) in 8bit-quoted-printable format v0.40.
Written by Evgeny Stepanischev. 2004.09.22.

Usage:
php -q {$argv[0]} [-t smtp_server] ["from"] "to" "filename" ["filename"...]

smtp_server - SMTP server
from - sender email address (admin@example.com by default)
to - recipient email address
filename - one or more file(s) to attach
-------------------------------------------------------------------------------


HELP;

        exit;
    }

    $tmp = tmpfile();

    if (!$tmp)
    {
        echo 'Fatal error';
        exit;
    }

    B_Message::create
    (
        $tmp,
        $bound = "To.chto.est'-est'!".date('.d:m:Y:H:i:s'),
        $_SERVER['argv']
    );


    fseek($tmp, 0);
    B_Message::send
    (
        $smtp, 25, $from, $to,
        date('d.m.Y.H.i.s').'5463BDUASS2114',
        $tmp,
        implode(', ', array_map('basename', $_SERVER['argv']))
    );

    fclose($tmp);

    function U_fromto()
    {
        if (U_validatemailboxname(@$_SERVER['argv'][0]))
        $from = array_shift($_SERVER['argv']); else
        return array(null, null);

        if (U_validatemailboxname(@$_SERVER['argv'][0]))
        $to = array_shift($_SERVER['argv']); else
        {
            $to = $from;
            $from = 'admin@example.com';
        }

        return array($from, $to);
    }

    function U_validatemailboxname($email)
    {
        return strlen ($email) < 255 &&
        preg_match ('/^[a-zA-Z0-9][a-zA-Z0-9\-\.\_]{0,62}[\@]([a-zA-Z0-9\-]{1,62}[\.]){2,}$/', "$email.");
    }

?>